diff --git a/configs/A13-OLinuXino_defconfig b/configs/A13-OLinuXino_defconfig
index 2574018d8213..ae790164dff7 100644
--- a/configs/A13-OLinuXino_defconfig
+++ b/configs/A13-OLinuXino_defconfig
@@ -32,7 +32,4 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
diff --git a/configs/A20-OLinuXino-Lime2-eMMC_defconfig b/configs/A20-OLinuXino-Lime2-eMMC_defconfig
index 5663a824e71b..b136af66b71f 100644
--- a/configs/A20-OLinuXino-Lime2-eMMC_defconfig
+++ b/configs/A20-OLinuXino-Lime2-eMMC_defconfig
@@ -34,7 +34,4 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
diff --git a/configs/A20-OLinuXino-Lime2_defconfig b/configs/A20-OLinuXino-Lime2_defconfig
index 63d013293690..ebb435f30956 100644
--- a/configs/A20-OLinuXino-Lime2_defconfig
+++ b/configs/A20-OLinuXino-Lime2_defconfig
@@ -33,7 +33,4 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
diff --git a/configs/CHIP_defconfig b/configs/CHIP_defconfig
index 278039c05573..7d50d0533dcd 100644
--- a/configs/CHIP_defconfig
+++ b/configs/CHIP_defconfig
@@ -23,8 +23,5 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
 CONFIG_OF_LIBFDT_OVERLAY=y
diff --git a/configs/CHIP_pro_defconfig b/configs/CHIP_pro_defconfig
index edbdefc69ddf..76daf477ec87 100644
--- a/configs/CHIP_pro_defconfig
+++ b/configs/CHIP_pro_defconfig
@@ -28,8 +28,5 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
 CONFIG_OF_LIBFDT_OVERLAY=y
diff --git a/configs/Cubietruck_defconfig b/configs/Cubietruck_defconfig
index 2d1753645b0f..1b2989d364f6 100644
--- a/configs/Cubietruck_defconfig
+++ b/configs/Cubietruck_defconfig
@@ -33,7 +33,4 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
diff --git a/configs/Nintendo_NES_Classic_Edition_defconfig b/configs/Nintendo_NES_Classic_Edition_defconfig
index 99f7d30f150d..5986764a14b9 100644
--- a/configs/Nintendo_NES_Classic_Edition_defconfig
+++ b/configs/Nintendo_NES_Classic_Edition_defconfig
@@ -23,7 +23,4 @@ CONFIG_AXP_ELDO2_VOLT=1800
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
diff --git a/configs/Sinlinx_SinA33_defconfig b/configs/Sinlinx_SinA33_defconfig
index 8c5fc7587909..9299aedd6019 100644
--- a/configs/Sinlinx_SinA33_defconfig
+++ b/configs/Sinlinx_SinA33_defconfig
@@ -28,7 +28,4 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
diff --git a/configs/parrot_r16_defconfig b/configs/parrot_r16_defconfig
index 4b70fc5687eb..57db9587fe77 100644
--- a/configs/parrot_r16_defconfig
+++ b/configs/parrot_r16_defconfig
@@ -24,7 +24,4 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_MUSB_GADGET=y
 CONFIG_SYS_USB_EVENT_POLL_VIA_INT_QUEUE=y
 CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="Allwinner Technology"
-CONFIG_USB_GADGET_VENDOR_NUM=0x1f3a
-CONFIG_USB_GADGET_PRODUCT_NUM=0x1010
 CONFIG_USB_GADGET_DOWNLOAD=y
diff --git a/drivers/usb/gadget/Kconfig b/drivers/usb/gadget/Kconfig
index e463d1dee0e7..b6aea03f3949 100644
--- a/drivers/usb/gadget/Kconfig
+++ b/drivers/usb/gadget/Kconfig
@@ -38,12 +38,15 @@ if USB_GADGET
 
 config USB_GADGET_MANUFACTURER
 	string "Vendor name of USB device"
+	default "Allwinner Technology" if ARCH_SUNXI
 
 config USB_GADGET_VENDOR_NUM
 	hex "Vendor ID of USB device"
+	default 0x1f3a if ARCH_SUNXI
 
 config USB_GADGET_PRODUCT_NUM
 	hex "Product ID of USB device"
+	default 0x1010 if ARCH_SUNXI
 
 config USB_GADGET_ATMEL_USBA
 	bool "Atmel USBA"